<script setup>
import Constants from '@/Constants'
</script>


<script>
export default {

	data() {
		const params = new URLSearchParams(window.location.search)
		const trash = Number(params.get('trash')) ? 1 : 0
		return {
			data: JSON.parse(document.querySelector('meta[name="data"]').getAttribute('content')),
			params,
			page: Number(params.get('page')) ?? 0,
			order: params.get('order') ?? 'id',
			search: params.get('search') ?? '',
			trash,
			trashBin: trash.value ? this.$t('trash_') : this.$t('trash'),
			options: [
				{ value: 'id', text: this.$t('sortBy.id') },
				{ value: 'email', text: this.$t('sortBy.emailAsc') },
				{ value: 'email-', text: this.$t('sortBy.emailDesc') },
				{ value: 'created', text: this.$t('sortBy.signUpAsc') },
				{ value: 'created-', text: this.$t('sortBy.signUpDesc') },
			],
			items: null,
			pagination: null,
		}
	},

	methods: {
		conditionsToUrl() {
			const cond = `page=${this.page}`
				+ `&order=${this.order}`
				+ `&search=${this.search}`
				+ `&trash=${this.trash}`
			return cond
		},

		goToPage(diff) {
			if (diff < 0) {
				if (this.page > 0) {
					this.page--
					this.params.set('page', this.page.toString())
					this.$router.push(`/members?${this.params.toString()}`)
					this.refresh()
				}
			}
			else if (diff > 0) {
				if (this.page < this.pagination.pageCount - 1) {
					this.page++
					this.params.set('page', this.page.toString())
					this.$router.push(`/members?${this.params.toString()}`)
					this.refresh()
				}
			}
		},

		changeOrder(o) {
			this.params.set('order', this.order)
			this.$router.push(`/members?${this.params.toString()}`)
			//this.refresh()
		},

		setSearch() {
			this.params.set('search', this.search)
			this.$router.push(`/members?${this.params.toString()}`)
			//this.refresh()
		},

		switchTrash() {
			this.trash = !this.trash ? 1 : 0
			this.trashBin = this.trash ? this.$t('trash_') : this.$t('trash')
			this.params.set('trash', this.trash.toString())
			this.$router.push(`/members?${this.params.toString()}`)
			//this.refresh()
		},

		async refresh() {
			const cond = this.conditionsToUrl()
			//const url = `/members?size=1&${cond}`
			const url = `/members?${cond}`
			window.location.href = url
		},
	},

	mounted() {
		this.items = this.data.members
		this.pagination = this.data.pagination
	},

	i18n: {
		messages: {
			en: {
				title: "Members",
				sortBy: {
					id: "Id",
					emailAsc: "Email ASC",
					emailDesc: "Email DESC",
					signUpAsc: "Sign Up ASC",
					signUpDesc: "Sign Up DESC"
				},
				trash: "Disabled or Resigned",
				trash_: "Normal",
				reload: "Reload",
			},
			th: {
				title: "สมาชิก",
				sortBy: {
					id: "Id",
					emailAsc: "อีเมล น้อยไปมาก",
					emailDesc: "อีเมล มากไปน้อย",
					signUpAsc: "วันที่สมัคร น้อยไปมาก",
					signUpDesc: "วันที่สมัคร มากไปน้อย"
				},
				trash: "ถูกระงับการใช้งาน หรือ ลาออกจากระบบ",
				trash_: "ปกติ",
				reload: "รีโหลด",
			},
		},
	},
}
</script>


<template>
	<AppBox :title="$t('title')">
		<!-- ordering, searching and trashing -->
		<select v-model="order" @click.prevent="(e) => changeOrder(order)">
			<option v-for="option in options" :value="option.value">
				{{ option.text }}
			</option>
		</select>
		<input v-model="search" @keyup.enter="(e) => setSearch()" />
		<button @click.prevent="(e) => switchTrash()">{{ trashBin }}</button>
		<button @click.prevent="(e) => refresh()">{{ $t('reload') }}</button><br />
		<br />

		<!-- data -->
		<div v-for="(item, index) in items" :key="index" class="item">
			<!--<a :href="`/member/get/${item.email.replace(/\./g, () => '%2E')}`">-->
			<a :href="`/members/${item.email}`">
				<img :src="`${Constants.baseUrl}/members/${item.email}/icon`">
				<div>
					<span>{{ item.email }}</span>
					<span>{{ item.name }}</span>
				</div>
			</a>
		</div>
		<br />

		<!-- pagination -->
		<div v-if="pagination && pagination.pageCount > 0">
			<button @click.prevent="(e) => goToPage(-1)">&nbsp;&lt;&nbsp;</button>
			<span style="padding: 0 1rem">{{ `${pagination.page + 1} / ${pagination.pageCount}` }}</span>
			<button @click.prevent="(e) => goToPage(1)">&nbsp;&gt;&nbsp;</button>
		</div>
	</AppBox>
</template>


<style scoped>
.item a {
	display: block;
}

.item img {
	display: inline-block;
	width: 80px;
	height: 80px;
}

.item div {
	display: inline-block;
	margin: 0 0 0 1rem;
	padding: 0.5rem 0 0 0;
	vertical-align: top;
}

.item div span:nth-child(1) {
	display: block;
	font-size: 120%;
	color: #444;
}

.item div span:nth-child(2) {
	display: block;
	color: #888;
}

@media (prefers-color-scheme: dark) {
	.item div span:nth-child(1) {
		display: block;
		font-size: 120%;
		color: #ccc;
	}
}
</style>
